class Book
  attr_reader :title, :author

  def initialize(title, author)
    @title = title
    @author = author
  end
end

class BookShelf
  def initialize
    @books = []
  end

  def add(book)
    @books << book
  end

  def search(keyword)
    result = search_by_title_or_author(keyword)
    printout_result(result)
  end

  private
  # 結果出力部分をメソッド抽出
  def printout_result(result)
    return "検索結果は0件です" if result.size == 0

    <<-EOF
#{result.size}件ヒットしました
#{result.map{|r| "#{r.title}: #{r.author}著"}.join("\n")}
    EOF
  end

  def search_by_title_or_author(keyword)
    result = @books.select do |book|
      book.title =~ /#{keyword}/
    end
    result += @books.select do |book|
      book.author =~ /#{keyword}/
    end
  end
end
